Attribute VB_Name = "Utility"
Option Explicit

Public Const TIME_LEN = 6
Public Const CODE_LEN = 176
Public Const MAX_IR_BUS = 16

Public Const fmtIRCommand = 201


Public Type IRCOMMAND
    remote As String * 80
    command As String * 20
End Type

Public Type NETWORKCOMMAND
    netcommand As Byte
    mode As Byte
    timeout As Integer
    adress As Long
    protocol_version As Long
    remote As String * 80
    command As String * 20
    transmit_freq As Byte
End Type

Public Type SERCOMMAND
    netcommand As Byte
    mode As Byte
    timeout As Integer
    adress As Long
    protocol_version As Long
    len As Byte
    align As Byte
    align2 As Integer
    Data As String * 256
End Type


Public Type IRDBCOMMAND
    netcommand As Byte
    mode As Byte
    timeout As Integer              '4
    adress As Long                  '8
    protocol_version As Long        '12
    Number As Long                  '16
    relais As Byte                  '17
    type As Byte                    '18
    action_type As Byte             '19
    action_len As Byte              '20
    remote_num As Long              '24
    command_num As Long             '28
    ip As Long                      '32
    port As Integer                 '34
    align As Integer
    remote As String * 80           '114
    command As String * 20          '134
    action As String * 256
End Type

Public Type IRDBHEADER
    netcommand As Byte
    mode As Byte
    timeout As Integer
    adress As Long
    protocol_version As Long
    Number As Long
    active As Byte
    type As Byte
    dummy(0 To 1) As Byte
    default_action As String * 100
    err_status  As String * 20
    ok_status As String * 20
    inputmode(0 To 3) As Byte
    min(0 To 3) As Byte
    max(0 To 3) As Byte
    hyst(0 To 3) As Byte
    minledsel(0 To 3) As Byte
    maxledsel(0 To 3) As Byte
    minmask(0 To 3) As Long
    maxmask(0 To 3) As Long
    minremote(0 To 3) As String * 80
    mincommand(0 To 3) As String * 50
    maxremote(0 To 3) As String * 80
    maxcommand(0 To 3) As String * 50
End Type


Public Type MODECOMMAND
    netcommand As Byte
    mode As Byte
    timeout As Integer
    adress As Long
    protocol_version As Long
    hotremote As String * 80
    hotcommand As String * 20
    hotremote_2 As String * 80
    hotcommand_2 As String * 20
    targetmask As Long
    extmode As Byte
    extmode_2 As Byte
    extmode_3 As Byte
    extmode_4 As Byte
    wakeup_mac(0 To 5) As Byte
End Type

Public Type TRANSLATECOMMAND
    netcommand As Byte
    mode As Byte
    timeout As Integer
    adress As Long
    protocol_version As Long
    Number As Long
    setup As Byte
    type As Byte
    accelerator_timeout As Byte
    accelerator_repeat As Byte
    wait_timeout As Integer
    remote_num As Byte
    group_num As Byte
    remote As String * 80
    command As String * 20
    source_mask As Long
    target_mask As Long
    multi_num As Byte
    include_names As Byte
    dummy(0 To 1) As Byte
End Type

Public Type TIMINGDATA
    mode As Byte
    time_cnt As Byte
    ir_repeat As Byte
    repeat_pause As Byte
    pause_len(0 To TIME_LEN - 1) As Integer
    pulse_len(0 To TIME_LEN - 1) As Integer
    Data As String * CODE_LEN
End Type


Public Type MODELINE
    send_mask As Long
    device_mode As Byte
    extended_mode As Byte
    extended_mode2 As Byte
    align As Byte
    switch_mode As Integer
    switch_mode2 As Integer
    features As Long
    extended_mode3 As Byte
    extended_mode4 As Byte
    version As String * 10
    remote As String * 80
    command As String * 20
    remote2 As String * 80
    command2 As String * 20
End Type

Public Type STATUSBUFFER
    clientid As Long
    statuslen As Integer
    statustype As Integer
End Type

Public Type NETWORKSTATUS
    adress As Integer
    netstatus As Integer
    statuslevel As Integer
    align(0 To 1) As Byte
    message As String * 256
End Type

Public Type FUNCTIONSTATUS
    serno As Long
    functions As Long
End Type

Public Type ANALOGSTATUS
    len As Byte
    mode(0 To 7) As Byte
    value(0 To 7) As Byte
End Type

Public Type IRDBSTATUS
    memsize As String * 32
    flashsize As String * 8
    remotes As String * 8
    commands As String * 8
    actions As String * 8
End Type

Public Type FUNCTIONSTATUSEX
    serno As Long
    functions As Long
    version As String * 8
End Type

Public Type REMOTELINE
    target_mask As Long
    source_mask As Long
    name As String * 80
End Type

Public Type TRANSLATEBUFFER
    offset As Integer
    count_buffer As Integer
    count_total As Integer
    count_remaining As Integer
    trans(0 To 29) As TRANSLATECOMMAND
End Type

Public Type IRDBBUFFER
    offset As Integer
    count_buffer As Integer
    count_total As Integer
    count_remaining As Integer
    irdb(0 To 11) As IRDBCOMMAND
End Type

Public Type IRDBHEADERBUFFER
    offset As Integer
    count_buffer As Integer
    count_total As Integer
    count_remaining As Integer
    header As IRDBHEADER
End Type

Public Type REMOTEBUFFER
    offset As Integer
    count_buffer As Integer
    count_total As Integer
    count_remaining As Integer
    remotes(0 To 39) As REMOTELINE
End Type

Public Type COMMANDBUFFER
    offset As Integer
    count_buffer As Integer
    count_total As Integer
    count_remaining As Integer
    commands(0 To 199) As String * 20
End Type

Public Type NETWORKMODE
    adress As Integer
    align(0 To 1) As Byte
    stat(0 To 15) As MODELINE
End Type


Public Type NETWORKMODEEX
    adress As Integer
    offset As Byte
    count As Byte
    dev_adr(0 To 7) As Byte
    stat(0 To 15, 0 To 7) As MODELINE
End Type

Public Type NETWORKTIMING
    adress As Integer
    align(0 To 1) As Byte
    timing As TIMINGDATA
End Type

Public Type NETWORKRECV
    adress As Integer
    align(0 To 1) As Byte
    remote As String * 80
    command As String * 20
    Data As String * 200
End Type

Public Type NETWORKLEARNSTAT
    adress As Integer
    learnok As Integer
    remote As String * 80
    num_timings As Integer
    num_commands As Integer
    received As String * CODE_LEN
End Type



Public Const COMMAND_SEND = 1
Public Const COMMAND_LRNREM = 2
Public Const COMMAND_LRNTIM = 3
Public Const COMMAND_LRNCOM = 4
Public Const COMMAND_CLOSE = 5
Public Const COMMAND_STATUS = 6
Public Const COMMAND_RESEND = 7
Public Const COMMAND_LRNRAW = 8
Public Const COMMAND_LRNRPT = 9
Public Const COMMAND_LRNTOG = 10
Public Const COMMAND_SETSTAT = 11
Public Const COMMAND_LRNLONG = 12
Public Const COMMAND_LRNRAWRPT = 13
Public Const COMMAND_RELOAD = 14
Public Const COMMAND_LEARNSTAT = 16
Public Const COMMAND_TEMP = 17
Public Const COMMAND_GETREMOTES = 18
Public Const COMMAND_GETCOMMANDS = 19
Public Const COMMAND_STORETRANS = 20
Public Const COMMAND_LOADTRANS = 21
Public Const COMMAND_SAVETRANS = 22
Public Const COMMAND_FLASHTRANS = 23
Public Const COMMAND_FUNCTIONS = 24
Public Const COMMAND_TESTCOM = 25
Public Const COMMAND_STATUSEX = 31
Public Const COMMAND_FUNCTIONEX = 36
Public Const COMMAND_DELETECOM = 40
Public Const COMMAND_SETSTAT2 = 42
Public Const COMMAND_STATUSEXN = 43
Public Const COMMAND_STOREIRDB = 46
Public Const COMMAND_FLASHIRDB = 47
Public Const COMMAND_SAVEIRDB = 48
Public Const COMMAND_LOADIRDB = 49
Public Const COMMAND_TRANSFILE = 51
Public Const COMMAND_IRDBFILE = 52
Public Const COMMAND_TESTCOMEX = 56
Public Const COMMAND_SETSTATEX = 58
Public Const COMMAND_READ_ANALOG = 60
Public Const COMMAND_SEND_RS232 = 61


Public Const FN_IR = 1
Public Const FN_SBUS = 2
Public Const FN_SER = 4
Public Const FN_USB = 8
Public Const FN_POWERON = 16
Public Const FN_B_O = 32
Public Const FN_TEMP = 64
Public Const FN_SOFTID = 128
Public Const FN_EEPROM = 256
Public Const FN_TRANSL = 512
Public Const FN_HWCARR = 1024
Public Const FN_DUALRCV = 2048
Public Const FN_SBUS_UART = 4096
Public Const FN_FLASH128 = 8192
Public Const FN_DUALSND = 16384
Public Const FN_BOOTLOADER = &H100000
Public Const FN_DUALPOWERON = &H200000
Public Const FN_USBWAKEUP = &H400000
'Public Const FN_SBUS_HP = &H800000
Public Const FN_LAN = &H1000000
Public Const FN_IRDB = &H2000000
Public Const FN_HTML = &H80000000


Public Const MODE_SEND = 1
Public Const MODE_LEARN = 2
Public Const MODE_STATUS = 3
Public Const MODE_REMOTE = 4
Public Const MODE_TIMING = 5
Public Const MODE_TRANSLATOR = 6
Public Const MODE_IRDB = 7
Public Const MODE_SAVE_TRANSLATOR = 6
Public Const MODE_SAVE_IRDB = 7


Public Const IRDB_REMOTE = 8
Public Const IRDB_HEADER = 9
Public Const IRDB_ACTION = 10
Public Const IRDB_ACTION_1 = 11
Public Const IRDB_ACTION_2 = 12



Public Const DEVMODE_SEND = 1
Public Const DEVMODE_IR = 2
Public Const DEVMODE_SBUS = 4
Public Const DEVMODE_IRCODE = 8
Public Const DEVMODE_SBUSCODE = 16
Public Const DEVMODE_RAW = 32
Public Const DEVMODE_RAWFAST = 64
Public Const DEVMODE_REPEAT = 128

Public Const STATUS_MESSAGE = 1
Public Const STATUS_TIMING = 2
Public Const STATUS_DEVICEMODE = 3
Public Const STATUS_RECEIVE = 4
Public Const STATUS_LEARN = 5
Public Const STATUS_REMOTELIST = 6
Public Const STATUS_COMMANDLIST = 7
Public Const STATUS_TRANSLATE = 8
Public Const STATUS_FUNCTION = 9
Public Const STATUS_DEVICEMODEEX = 10
Public Const STATUS_FUNCTIONEX = 13
Public Const STATUS_DEVICEMODEEXN = 14
Public Const STATUS_IRDB = 15
Public Const STATUS_TRANSLATIONFILE = 16
Public Const STATUS_IRDBFILE = 17
Public Const STATUS_IRDBFLASH = 20
Public Const STATUS_ANALOGINPUT = 21

Public Const ERR_TESTCOM = 28
Public Const ERR_TESTCOMOK = 38


Public Type CONNECTPARAM
    type As Long
End Type

Public intIRFreq As Integer
Public lngTimeout As Long
Public ShowTiming As Byte
Public DeviceModesB As NETWORKMODEEX
Public DeviceModes(0 To 7) As NETWORKMODEEX
Public mode As Integer

Public RemoteCount As Integer
Public RemoteDB() As REMOTELINE

Public CommandCount As Integer
Public CommandDB() As String * 20
Public TargetCount As Integer
Public TargetDB() As String * 20
Public SendCount As Integer
Public SendDB() As String * 20
Public functions As Long
Public serialno As Long
Public version As String

Public RemoteListTarget As Integer
Public TranslatorStatus As Boolean
Public IRDBSTATUS As Boolean
Public errflag As Boolean
Public ns As NETWORKSTATUS


Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Public Function PutPortToString(port As Integer) As String
    Dim value As Long
    If port And &H8000 Then
        value = port And &H7FFF Or 32768
    Else
        value = port
    End If
    PutPortToString = Format("0" & value, "00000")
End Function

Public Function GetPortFromString(str As String) As Integer
    Dim value As Long
    value = Val(Mid(str, 1, 5))
    If value >= 32768 Then
        value = value - 32768
        GetPortFromString = value Or &H8000
    Else
        GetPortFromString = value
    End If
End Function

Public Function PutIPToString(ip As Long) As String
    If (ip And &H80000000) Then
        ip = ip And &H7FFFFFFF
        PutIPToString = Format("0" & ((ip \ 16777216) And 255) Or 128, "000")
    Else
        PutIPToString = Format("0" & (ip \ 16777216) And 255, "000")
    End If
    PutIPToString = PutIPToString & _
        Format("0" & (ip \ 65536) And 255, "000") & _
        Format("0" & (ip \ 256) And 255, "000") & _
        Format("0" & (ip) And 255, "000")
End Function

Public Function GetIPFromString(str As String) As Long
    If Mid(str, 1, 3) >= 128 Then
        GetIPFromString = (Mid(str, 1, 3) - 128) * 16777216 Or &H80000000
    Else
        GetIPFromString = Mid(str, 1, 3) * 16777216
    End If
    
    GetIPFromString = GetIPFromString Or Mid(str, 4, 3) * 65536 Or Mid(str, 7, 3) * 256 Or Mid(str, 10, 3)
End Function


Public Sub HandleASCIIResult(strRes As String, lngLen As Long)
    strRes = Left(strRes, Len(strRes) - 1)
    
    If (Left(strRes, 20) = "RESULT_HTML_FILELIST") Then
        frmHTML.FillHTMLFilelist Mid(strRes, 22)
    End If
    
    If (Left(strRes, 17) = "RESULT_HTML_FLASH") Then
        If Mid(strRes, 19, 1) = "E" Then
            MsgBox "Error flashing HTML Pages" & vbCr & Mid(strRes, 20), vbExclamation, "HTML Flash"
        End If
        If Mid(strRes, 19, 1) = "O" Then
            MsgBox "HTML Flash OK: " & Mid(strRes, 20) & " Bytes", , "HTML Flash"
        End If
    End If

End Sub

Public Sub SocketSendCommand(nc As NETWORKCOMMAND, sock As Winsock)
Dim buf() As Byte
    
    nc.remote = Trim(nc.remote) & Chr(0)
    nc.command = Trim(nc.command) & Chr(0)
    nc.protocol_version = 210
    
    ReDim buf(Len(nc) - 1)
    CopyMemory buf(0), nc, Len(nc)
    
    sock.SendData buf
End Sub

Public Sub SocketSendMode(mc As MODECOMMAND, sock As Winsock)
Dim buf() As Byte
    
    mc.hotremote = Trim(mc.hotremote) & Chr(0)
    mc.hotcommand = Trim(mc.hotcommand) & Chr(0)
    mc.hotremote_2 = Trim(mc.hotremote_2) & Chr(0)
    mc.hotcommand_2 = Trim(mc.hotcommand_2) & Chr(0)
    mc.protocol_version = 210
    
    ReDim buf(Len(mc) - 1)
    CopyMemory buf(0), mc, Len(mc)
    
    sock.SendData buf
End Sub

Public Sub SocketSendTransfer(tr As TRANSLATECOMMAND, sock As Winsock)
Dim buf() As Byte
    
    tr.netcommand = COMMAND_STORETRANS
    tr.remote = Trim(tr.remote) & Chr(0)
    tr.command = Trim(tr.command) & Chr(0)
    tr.protocol_version = 210
    
    ReDim buf(Len(tr) - 1)
    CopyMemory buf(0), tr, Len(tr)
    
    sock.SendData buf
End Sub

Public Sub SocketSendIRDBHeader(ir As IRDBHEADER, sock As Winsock)
Dim buf() As Byte
Dim i As Integer
    
    ir.netcommand = COMMAND_STOREIRDB
    ir.protocol_version = 210
    ir.default_action = Trim(ir.default_action) & Chr(0)
    ir.ok_status = Trim(ir.ok_status) & Chr(0)
    ir.err_status = Trim(ir.err_status) & Chr(0)
    
    For i = 0 To 3
        ir.minremote(i) = Trim(ir.minremote(i)) & Chr(0)
        ir.mincommand(i) = Trim(ir.mincommand(i)) & Chr(0)
        ir.maxremote(i) = Trim(ir.maxremote(i)) & Chr(0)
        ir.maxcommand(i) = Trim(ir.maxcommand(i)) & Chr(0)
    Next i
    
    ReDim buf(Len(ir) - 1)
    CopyMemory buf(0), ir, Len(ir)
    
    sock.SendData buf
End Sub


Public Sub SocketSendIRDB(ir As IRDBCOMMAND, sock As Winsock)
Dim buf() As Byte
    
    ir.netcommand = COMMAND_STOREIRDB
    ir.remote = Trim(ir.remote) & Chr(0)
    ir.command = Trim(ir.command) & Chr(0)
    ir.action = Trim(ir.action) & Chr(0)
    ir.protocol_version = 210
    
    ReDim buf(Len(ir) - 1)
    CopyMemory buf(0), ir, Len(ir)
    
    sock.SendData buf
End Sub


Public Sub SocketSendStatus(id As Long, sock As Winsock)
Dim cp As CONNECTPARAM
Dim buf() As Byte
    
    cp.type = id
    
    ReDim buf(Len(cp) - 1)
    CopyMemory buf(0), cp, Len(cp)
    sock.SendData buf
End Sub

